/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.konfiguration.entity;

@javax.persistence.NamedQueries(
 {



       @javax.persistence.NamedQuery(
     name="KONFIGURATION.UK",
     query="SELECT o FROM Konfiguration o WHERE "

                         + "o"
                +".schluessel"
              +" = ?1"

             +" AND "         + "o"
                +".mandant"
                +".nummer"
              +" = ?2"

     ,
   hints = {
              @javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
             @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
   }


   )
   
     ,   @javax.persistence.NamedQuery(
     name="KONFIGURATION.Mandant",
     query="SELECT OBJECT(o) FROM Konfiguration o WHERE o.mandant=?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="KONFIGURATION.MandantSchluessel",
     query="SELECT k FROM Konfiguration k WHERE k.mandant=?1 AND k.schluessel = ?2",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="KONFIGURATION.SystemSchluessel",
     query="SELECT k FROM Konfiguration k WHERE k.schluessel = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "KONFIGURATION")
// @javax.persistence.IdClass(KonfigurationPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class Konfiguration
extends AbstractKonfiguration
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public Konfiguration() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public Konfiguration(Konfiguration original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "konfiguration_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "Konfiguration")
    @javax.persistence.TableGenerator(name = "Konfiguration", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "Konfiguration", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient KonfigurationPK pkCache;

  @Override
  public KonfigurationPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new KonfigurationPK(getId());
    }

    return pkCache;
  }

  public static <E extends Konfiguration> java.util.Map<KonfigurationPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<KonfigurationPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends Konfiguration> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;



  public void resetAttributeChanged() {
        hasChangedSchluessel = false;
          hasChangedWert = false;
  
      hasChangedMandant = false;
  


    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
      @javax.persistence.Column(name = "SCHLUESSEL", nullable = KonfigurationConstants.SCHLUESSEL_NULLABLE, length=KonfigurationConstants.SCHLUESSEL_MAX_LENGTH)
        
  protected String schluessel =  null;

  @javax.persistence.Transient
  protected boolean hasChangedSchluessel = false;

  public boolean hasChangedSchluessel(){
    return hasChangedSchluessel;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertSchluessel = false;
     @javax.persistence.Transient
     private transient String wertNachLadenSchluessel;
  
  /**
   * 
   *
   * getter for KONFIGURATION.SCHLUESSEL
   */
    @Override   public  String getSchluessel() {
        return schluessel;
      }

  /**
   * 
   *
   * setter for KONFIGURATION.SCHLUESSEL
   *
   * @param schluessel
   */
  @Override   public void setSchluessel( String schluessel) {

       resetTkCache();
                  
                          String schluesselInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(schluessel, KonfigurationConstants.SCHLUESSEL_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.schluessel
      , schluesselInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedSchluessel |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("schluessel");
      }


             if (!isSeitLadenVeraendertSchluessel) {
          isSeitLadenVeraendertSchluessel = thisAttributChanged;
         if (isSeitLadenVeraendertSchluessel){
           wertNachLadenSchluessel=this.schluessel;
         }
       }
      

       this.schluessel = schluesselInternal;

         }

        
  @javax.persistence.Column(name = "WERT", nullable = KonfigurationConstants.WERT_NULLABLE, length=KonfigurationConstants.WERT_MAX_LENGTH)
        
  protected String wert =  null;

  @javax.persistence.Transient
  protected boolean hasChangedWert = false;

  public boolean hasChangedWert(){
    return hasChangedWert;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertWert = false;
     @javax.persistence.Transient
     private transient String wertNachLadenWert;
  
  /**
   * 
   *
   * getter for KONFIGURATION.WERT
   */
  @javax.annotation.Nullable   @Override   public  String getWert() {
        return wert;
      }

  /**
   * 
   *
   * setter for KONFIGURATION.WERT
   *
   * @param wert
   */
  @Override   public void setWert(@javax.annotation.Nullable  String wert) {

       resetTkCache();
                  
                          String wertInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(wert, KonfigurationConstants.WERT_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wert
      , wertInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedWert |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("wert");
      }


             if (!isSeitLadenVeraendertWert) {
          isSeitLadenVeraendertWert = thisAttributChanged;
         if (isSeitLadenVeraendertWert){
           wertNachLadenWert=this.wert;
         }
       }
      

       this.wert = wertInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu Mandant
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "MANDANT_ID", referencedColumnName="MANDANT_ID"))
  protected de.ivu.elect.business.mandant.entity.Mandant mandant;

  /**
   * 
   */
  @Override
  public void setMandant( de.ivu.elect.business.mandant.entity.Mandant mandant){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.mandant
    , mandant);

    attributeChanged |= thisAttributChanged;

    hasChangedMandant |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("mandant");
    }

    this.mandant = mandant;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.mandant.entity.Mandant getMandant(){
    return this.mandant;
  }

  @javax.persistence.Transient
  protected boolean hasChangedMandant = false;

  public boolean hasChangedMandant(){
    return hasChangedMandant;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("Konfiguration:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(Konfiguration other){
                             other.schluessel = this.schluessel;
                                other.wert = this.wert;
           
  other.setMandant(this.getMandant());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(Konfiguration.class)){
        copyEntityAttributesUsingSetter((Konfiguration) other.castTo(Konfiguration.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von Konfiguration: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(Konfiguration other){
               other.setSchluessel(this.schluessel);
                  other.setWert(this.wert);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(Konfiguration other){
                       if (hasChangedSchluessel) {
        other.setSchluessel(this.schluessel);
      }
                             if (hasChangedWert) {
        other.setWert(this.wert);
      }
             }





    @javax.persistence.Transient
    private transient KonfigurationTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public KonfigurationTK getKonfigurationTK(){
    if (tkCache==null) {
    tkCache = new KonfigurationTK(

getSchluessel()


  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getKonfigurationTK();
    }

  @Override
  public KonfigurationUK getUk(){
    return getKonfigurationUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return Konfiguration.class;
  }

public KonfigurationUK getKonfigurationUK(){

   return  new KonfigurationUK(

getSchluessel()
,     getMandant()==null?null:getMandant().getMandantUK()


  );
}

  @javax.persistence.Transient
  private transient KonfigurationProperties properties;

  public KonfigurationProperties getProperties(){
    if (properties == null) {
      properties = new KonfigurationProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public KonfigurationProperties getKonfigurationProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return KonfigurationConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(KonfigurationConstants.MESSAGE_KEY_SCHLUESSEL_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(KonfigurationConstants.MESSAGE_KEY_SCHLUESSEL_EINZAHL);

        schluessel =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(KonfigurationConstants.MESSAGE_KEY_WERT_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(KonfigurationConstants.MESSAGE_KEY_WERT_EINZAHL);

        wert =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertSchluessel) {
      result.put(KonfigurationConstants.MESSAGE_KEY_SCHLUESSEL_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenSchluessel , schluessel));
    }
                            if (isSeitLadenVeraendertWert) {
      result.put(KonfigurationConstants.MESSAGE_KEY_WERT_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenWert , wert));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertSchluessel = false;
      wertNachLadenSchluessel = null;
                          isSeitLadenVeraendertWert = false;
      wertNachLadenWert = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                    return result;
  }

        
            protected String getInitialDiscriminator() {
              return "KONFIGURATION";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "Konfiguration";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

    @Override
    public int hashCode() {

      if (id==null){
        return super.hashCode();
      }
      return id.hashCode();
    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(schluessel, this, KonfigurationConstants.MESSAGE_KEY_SCHLUESSEL_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(KonfigurationConstants.SCHLUESSEL_MAX_LENGTH , 1 ,  schluessel, this, KonfigurationConstants.MESSAGE_KEY_SCHLUESSEL_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(KonfigurationConstants.WERT_MAX_LENGTH ,  wert, this, KonfigurationConstants.MESSAGE_KEY_WERT_EINZAHL, validationResult);
                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }

              }
